import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * https://static.pexels.com/photos/110854/pexels-photo-110854.jpeg 
 * 

 */
public class Space extends World
{
    private int score;
    private int time;
    public int points;
    /**
     * Constructor: Set up the staring objects.
     */
    public Space()
    {    
        super(780, 360, 1); 
        setPaintOrder(Telescope.class);
        prepare();
        addScore(+ points);
        showTime();
        time = 2000;
        showScore();
    }

    private void showScore()
    {
        showText("Score:" + score, 80 , 25);
    }

    public void addScore(int points)
    {
        score = score + points;
        showText("Score:" + score, 80 , 25);
        if (score < 0)
        {
            Greenfoot.playSound("end.wav");
            Greenfoot.stop();
        }
    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new BlackAsteroid(), 779, Greenfoot.getRandomNumber(360));
            //BlackAsteroid
        }
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Asteroid(), 779, Greenfoot.getRandomNumber(360));
            //Asteroid
        }
        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Belt(), 779, 375);
            //topBelt
        }
        if (Greenfoot.getRandomNumber(100) < 2)
        {
            addObject(new Belt(), 779, 20);
            //bottomBelt

        }
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Debris(), 779, Greenfoot.getRandomNumber(360));
            //Debris
        }

        countTime (); 
    }

    private void countTime()
    {
        time--;
        showTime();
        if (time == 0)
        {
            showEndMessage();
            Greenfoot.stop();
            Greenfoot.playSound("win.wav");
        }
    }

    private void showTime()
    {
        showText("Time: " + time, 700, 25);
    }

    private void showEndMessage()
    {
        showText ("Time is up - you win!", 390, 150);
        showText("Your final score: " + score + " points", 390, 170);
    }

    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the Belt at the edge of the blood stream.
     */
    private void prepare()
    {
        SpaceShip SpaceShip = new SpaceShip();
        addObject(SpaceShip, 83, 179);
        Belt Belt = new Belt();
        addObject(Belt, 126, 1);
        Belt Belt2 = new Belt();
        addObject(Belt2, 342, 5);
        Belt Belt3 = new Belt();
        addObject(Belt3, 589, 2);
        Belt Belt4 = new Belt();
        addObject(Belt4, 695, 5);
        Belt Belt5 = new Belt();
        addObject(Belt5, 114, 359);
        Belt Belt6 = new Belt();
        Belt Belt7 = new Belt();
        addObject(Belt7, 295, 353);
        Belt Belt8 = new Belt();
        Belt Belt9 = new Belt();
        Belt Belt10 = new Belt();
        addObject(Belt10, 480, 358);
        Belt Belt11 = new Belt();
        addObject(Belt11, 596, 359);
        Belt Belt12 = new Belt();
        addObject(Belt12, 740, 354);
        Telescope Telescope = new Telescope();
        addObject(Telescope,770,180);
        SpaceShip.setLocation(225,181);
        SpaceShip.setLocation(169,185);
        Telescope Telescope2 = new Telescope();
        addObject(Telescope2,0,180);
        SpaceShip.setLocation(238,194);
        Telescope.setLocation(770,180);
        Telescope2.setLocation(0,180);
        SpaceShip.setLocation(118,188);
        SpaceShip.setLocation(94,177);
        SpaceShip.setLocation(127,190);
    }
}
