import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * BlackAsteroid and remove them from the blood.
 * 

 */
public class SpaceShip extends Actor
{
    private int score;

    /**
     * http://www.clipartlord.com/category/space-clip-art/spaceship-clip-art/page/2/ 
     */
    public void act() 
    {

        checkKeyPress();
        checkCollision();
        lookForAsteroid();

        score = 0;

    }


    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-4);
        }

        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+4);
        }
        
         if (Greenfoot.isKeyDown("left")) 
        {
            setLocation(getX()-4, getY());
        }

        if (Greenfoot.isKeyDown("right")) 
        {
            setLocation(getX()+4, getY());
        }
    }

    public void checkCollision()
    {
        if ( isTouching(BlackAsteroid.class) ) 
        {            
            Greenfoot.playSound("break.wav");
            removeTouching(BlackAsteroid.class);
            Space Space = (Space)getWorld();
            Space.addScore(20);
        }
    }

    public void lookForAsteroid()
    {
        if ( isTouching(Asteroid.class) ) 
        {
            Greenfoot.playSound("break.wav");
            removeTouching(Asteroid.class);
            Space Space = (Space)getWorld();
            Space.addScore(-100);
        }
    }
}
